/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is regenerated.
 */
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@azure/ms-rest-js'), require('@azure/ms-rest-azure-js')) :
    typeof define === 'function' && define.amd ? define(['exports', '@azure/ms-rest-js', '@azure/ms-rest-azure-js'], factory) :
    (global = global || self, factory((global.Azure = global.Azure || {}, global.Azure.ArmReservations = {}), global.msRest, global.msRestAzure));
}(this, (function (exports, msRest, msRestAzure) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var index = /*#__PURE__*/Object.freeze({
        __proto__: null
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */
    var CloudError = msRestAzure.CloudErrorMapper;
    var BaseResource = msRestAzure.BaseResourceMapper;
    var ResourceName = {
        serializedName: "ResourceName",
        type: {
            name: "Composite",
            className: "ResourceName",
            modelProperties: {
                value: {
                    serializedName: "value",
                    type: {
                        name: "String"
                    }
                },
                localizedValue: {
                    readOnly: true,
                    serializedName: "localizedValue",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var QuotaProperties = {
        serializedName: "QuotaProperties",
        type: {
            name: "Composite",
            className: "QuotaProperties",
            modelProperties: {
                limit: {
                    serializedName: "limit",
                    type: {
                        name: "Number"
                    }
                },
                currentValue: {
                    readOnly: true,
                    serializedName: "currentValue",
                    type: {
                        name: "Number"
                    }
                },
                unit: {
                    serializedName: "unit",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    serializedName: "name",
                    type: {
                        name: "Composite",
                        className: "ResourceName"
                    }
                },
                resourceType: {
                    serializedName: "resourceType",
                    type: {
                        name: "Object"
                    }
                },
                quotaPeriod: {
                    readOnly: true,
                    serializedName: "quotaPeriod",
                    type: {
                        name: "String"
                    }
                },
                properties: {
                    serializedName: "properties",
                    type: {
                        name: "Object"
                    }
                }
            }
        }
    };
    var CurrentQuotaLimitBase = {
        serializedName: "CurrentQuotaLimitBase",
        type: {
            name: "Composite",
            className: "CurrentQuotaLimitBase",
            modelProperties: {
                properties: {
                    serializedName: "properties",
                    type: {
                        name: "Composite",
                        className: "QuotaProperties"
                    }
                }
            }
        }
    };
    var CurrentQuotaLimit = {
        serializedName: "CurrentQuotaLimit",
        type: {
            name: "Composite",
            className: "CurrentQuotaLimit",
            modelProperties: {
                properties: {
                    serializedName: "quotaInformation.properties",
                    type: {
                        name: "Composite",
                        className: "QuotaProperties"
                    }
                },
                provisioningState: {
                    readOnly: true,
                    serializedName: "properties.provisioningState",
                    type: {
                        name: "Object"
                    }
                },
                message: {
                    readOnly: true,
                    serializedName: "properties.message",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var QuotaLimitsResponse = {
        serializedName: "QuotaLimitsResponse",
        type: {
            name: "Composite",
            className: "QuotaLimitsResponse",
            modelProperties: {
                value: {
                    serializedName: "value",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "CurrentQuotaLimit"
                            }
                        }
                    }
                },
                nextLink: {
                    serializedName: "nextLink",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var CreateGenericQuotaRequestParameters = {
        serializedName: "CreateGenericQuotaRequestParameters",
        type: {
            name: "Composite",
            className: "CreateGenericQuotaRequestParameters",
            modelProperties: {
                value: {
                    serializedName: "value",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "CurrentQuotaLimitBase"
                            }
                        }
                    }
                }
            }
        }
    };
    var SubRequest = {
        serializedName: "SubRequest",
        type: {
            name: "Composite",
            className: "SubRequest",
            modelProperties: {
                limit: {
                    readOnly: true,
                    serializedName: "limit",
                    type: {
                        name: "Number"
                    }
                },
                name: {
                    serializedName: "name",
                    type: {
                        name: "Composite",
                        className: "ResourceName"
                    }
                },
                resourceType: {
                    readOnly: true,
                    serializedName: "resourceType",
                    type: {
                        name: "String"
                    }
                },
                unit: {
                    serializedName: "unit",
                    type: {
                        name: "String"
                    }
                },
                provisioningState: {
                    serializedName: "provisioningState",
                    type: {
                        name: "Object"
                    }
                },
                message: {
                    readOnly: true,
                    serializedName: "message",
                    type: {
                        name: "String"
                    }
                },
                subRequestId: {
                    readOnly: true,
                    serializedName: "subRequestId",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var QuotaRequestOneResourceSubmitResponse = {
        serializedName: "QuotaRequestOneResourceSubmitResponse",
        type: {
            name: "Composite",
            className: "QuotaRequestOneResourceSubmitResponse",
            modelProperties: {
                id: {
                    readOnly: true,
                    serializedName: "id",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                type: {
                    readOnly: true,
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                },
                provisioningState: {
                    readOnly: true,
                    serializedName: "properties.provisioningState",
                    type: {
                        name: "Object"
                    }
                },
                message: {
                    readOnly: true,
                    serializedName: "properties.message",
                    type: {
                        name: "String"
                    }
                },
                requestSubmitTime: {
                    readOnly: true,
                    serializedName: "properties.requestSubmitTime",
                    type: {
                        name: "DateTime"
                    }
                },
                properties: {
                    serializedName: "properties.properties.properties",
                    type: {
                        name: "Composite",
                        className: "QuotaProperties"
                    }
                }
            }
        }
    };
    var QuotaRequestProperties = {
        serializedName: "QuotaRequestProperties",
        type: {
            name: "Composite",
            className: "QuotaRequestProperties",
            modelProperties: {
                provisioningState: {
                    serializedName: "provisioningState",
                    type: {
                        name: "Object"
                    }
                },
                message: {
                    readOnly: true,
                    serializedName: "message",
                    type: {
                        name: "String"
                    }
                },
                requestSubmitTime: {
                    readOnly: true,
                    serializedName: "requestSubmitTime",
                    type: {
                        name: "DateTime"
                    }
                },
                value: {
                    serializedName: "value",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "SubRequest"
                            }
                        }
                    }
                }
            }
        }
    };
    var QuotaRequestSubmitResponse = {
        serializedName: "QuotaRequestSubmitResponse",
        type: {
            name: "Composite",
            className: "QuotaRequestSubmitResponse",
            modelProperties: {
                id: {
                    readOnly: true,
                    serializedName: "id",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                properties: {
                    serializedName: "properties",
                    type: {
                        name: "Composite",
                        className: "QuotaRequestProperties"
                    }
                },
                type: {
                    readOnly: true,
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var QuotaRequestSubmitResponse201 = {
        serializedName: "QuotaRequestSubmitResponse201",
        type: {
            name: "Composite",
            className: "QuotaRequestSubmitResponse201",
            modelProperties: {
                id: {
                    readOnly: true,
                    serializedName: "id",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                type: {
                    readOnly: true,
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                },
                provisioningState: {
                    readOnly: true,
                    serializedName: "properties.provisioningState",
                    type: {
                        name: "Object"
                    }
                },
                message: {
                    readOnly: true,
                    serializedName: "properties.message",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var QuotaRequestDetails = {
        serializedName: "QuotaRequestDetails",
        type: {
            name: "Composite",
            className: "QuotaRequestDetails",
            modelProperties: {
                id: {
                    readOnly: true,
                    serializedName: "id",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                provisioningState: {
                    serializedName: "properties.provisioningState",
                    type: {
                        name: "Object"
                    }
                },
                message: {
                    readOnly: true,
                    serializedName: "properties.message",
                    type: {
                        name: "String"
                    }
                },
                requestSubmitTime: {
                    readOnly: true,
                    serializedName: "properties.requestSubmitTime",
                    type: {
                        name: "DateTime"
                    }
                },
                value: {
                    serializedName: "properties.value",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "SubRequest"
                            }
                        }
                    }
                },
                type: {
                    readOnly: true,
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var AqiSettings = {
        serializedName: "aqiSettings",
        type: {
            name: "Composite",
            className: "AqiSettings",
            modelProperties: {
                autoQuotaIncreaseState: {
                    serializedName: "autoQuotaIncreaseState",
                    type: {
                        name: "Object"
                    }
                }
            }
        }
    };
    var EmailAction = {
        serializedName: "EmailAction",
        type: {
            name: "Composite",
            className: "EmailAction",
            modelProperties: {
                emailAddress: {
                    serializedName: "emailAddress",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var EmailActions = {
        serializedName: "EmailActions",
        type: {
            name: "Composite",
            className: "EmailActions",
            modelProperties: {
                emailAddresses: {
                    serializedName: "emailAddresses",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "EmailAction"
                            }
                        }
                    }
                }
            }
        }
    };
    var Actions = {
        serializedName: "Actions",
        type: {
            name: "Composite",
            className: "Actions",
            modelProperties: {
                emailActions: {
                    serializedName: "emailActions",
                    type: {
                        name: "Composite",
                        className: "EmailActions"
                    }
                }
            }
        }
    };
    var SupportRequestAction = {
        serializedName: "SupportRequestAction",
        type: {
            name: "Composite",
            className: "SupportRequestAction",
            modelProperties: {
                severity: {
                    serializedName: "severity",
                    type: {
                        name: "Object"
                    }
                },
                firstName: {
                    serializedName: "firstName",
                    type: {
                        name: "String"
                    }
                },
                lastName: {
                    serializedName: "lastName",
                    type: {
                        name: "String"
                    }
                },
                country: {
                    serializedName: "country",
                    type: {
                        name: "String"
                    }
                },
                phoneNumber: {
                    serializedName: "phoneNumber",
                    type: {
                        name: "String"
                    }
                },
                primaryEmailAddress: {
                    serializedName: "primaryEmailAddress",
                    type: {
                        name: "String"
                    }
                },
                supportLanguage: {
                    serializedName: "supportLanguage",
                    type: {
                        name: "String"
                    }
                },
                preferredContactMethod: {
                    serializedName: "preferredContactMethod",
                    type: {
                        name: "Object"
                    }
                },
                alternateEmailAddresses: {
                    serializedName: "alternateEmailAddresses",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                }
            }
        }
    };
    var AutoQuotaIncreaseDetail = {
        serializedName: "AutoQuotaIncreaseDetail",
        type: {
            name: "Composite",
            className: "AutoQuotaIncreaseDetail",
            modelProperties: {
                id: {
                    readOnly: true,
                    serializedName: "id",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                type: {
                    readOnly: true,
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                },
                settings: {
                    serializedName: "properties.settings",
                    type: {
                        name: "Composite",
                        className: "AqiSettings"
                    }
                },
                onFailure: {
                    serializedName: "properties.onFailure",
                    type: {
                        name: "Composite",
                        className: "Actions"
                    }
                },
                onSuccess: {
                    serializedName: "properties.onSuccess",
                    type: {
                        name: "Composite",
                        className: "Actions"
                    }
                },
                supportTicketAction: {
                    serializedName: "properties.supportTicketAction",
                    type: {
                        name: "Composite",
                        className: "SupportRequestAction"
                    }
                }
            }
        }
    };
    var PhoneAction = {
        serializedName: "PhoneAction",
        type: {
            name: "Composite",
            className: "PhoneAction",
            modelProperties: {
                phoneNumber: {
                    serializedName: "phoneNumber",
                    type: {
                        name: "String"
                    }
                },
                preferredChannel: {
                    serializedName: "preferredChannel",
                    type: {
                        name: "Object"
                    }
                }
            }
        }
    };
    var ServiceErrorDetail = {
        serializedName: "ServiceErrorDetail",
        type: {
            name: "Composite",
            className: "ServiceErrorDetail",
            modelProperties: {
                code: {
                    readOnly: true,
                    serializedName: "code",
                    type: {
                        name: "String"
                    }
                },
                message: {
                    readOnly: true,
                    serializedName: "message",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ServiceError = {
        serializedName: "ServiceError",
        type: {
            name: "Composite",
            className: "ServiceError",
            modelProperties: {
                code: {
                    serializedName: "code",
                    type: {
                        name: "String"
                    }
                },
                message: {
                    serializedName: "message",
                    type: {
                        name: "String"
                    }
                },
                details: {
                    readOnly: true,
                    serializedName: "details",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "ServiceErrorDetail"
                            }
                        }
                    }
                }
            }
        }
    };
    var ExceptionResponse = {
        serializedName: "ExceptionResponse",
        type: {
            name: "Composite",
            className: "ExceptionResponse",
            modelProperties: {
                error: {
                    serializedName: "error",
                    type: {
                        name: "Composite",
                        className: "ServiceError"
                    }
                }
            }
        }
    };
    var SkuName = {
        serializedName: "SkuName",
        type: {
            name: "Composite",
            className: "SkuName",
            modelProperties: {
                name: {
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var SkuProperty = {
        serializedName: "SkuProperty",
        type: {
            name: "Composite",
            className: "SkuProperty",
            modelProperties: {
                name: {
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                value: {
                    serializedName: "value",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var SkuRestriction = {
        serializedName: "SkuRestriction",
        type: {
            name: "Composite",
            className: "SkuRestriction",
            modelProperties: {
                type: {
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                },
                values: {
                    serializedName: "values",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                },
                reasonCode: {
                    serializedName: "reasonCode",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var Catalog = {
        serializedName: "Catalog",
        type: {
            name: "Composite",
            className: "Catalog",
            modelProperties: {
                resourceType: {
                    readOnly: true,
                    serializedName: "resourceType",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                billingPlans: {
                    serializedName: "billingPlans",
                    type: {
                        name: "Dictionary",
                        value: {
                            type: {
                                name: "Sequence",
                                element: {
                                    type: {
                                        name: "String"
                                    }
                                }
                            }
                        }
                    }
                },
                terms: {
                    readOnly: true,
                    serializedName: "terms",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                },
                locations: {
                    readOnly: true,
                    serializedName: "locations",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                },
                skuProperties: {
                    readOnly: true,
                    serializedName: "skuProperties",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "SkuProperty"
                            }
                        }
                    }
                },
                restrictions: {
                    readOnly: true,
                    serializedName: "restrictions",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "SkuRestriction"
                            }
                        }
                    }
                }
            }
        }
    };
    var Price = {
        serializedName: "Price",
        type: {
            name: "Composite",
            className: "Price",
            modelProperties: {
                currencyCode: {
                    serializedName: "currencyCode",
                    type: {
                        name: "String"
                    }
                },
                amount: {
                    serializedName: "amount",
                    type: {
                        name: "Number"
                    }
                }
            }
        }
    };
    var ExtendedStatusInfo = {
        serializedName: "ExtendedStatusInfo",
        type: {
            name: "Composite",
            className: "ExtendedStatusInfo",
            modelProperties: {
                statusCode: {
                    serializedName: "statusCode",
                    type: {
                        name: "String"
                    }
                },
                message: {
                    serializedName: "message",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var PaymentDetail = {
        serializedName: "PaymentDetail",
        type: {
            name: "Composite",
            className: "PaymentDetail",
            modelProperties: {
                dueDate: {
                    serializedName: "dueDate",
                    type: {
                        name: "Date"
                    }
                },
                paymentDate: {
                    serializedName: "paymentDate",
                    type: {
                        name: "Date"
                    }
                },
                pricingCurrencyTotal: {
                    serializedName: "pricingCurrencyTotal",
                    type: {
                        name: "Composite",
                        className: "Price"
                    }
                },
                billingCurrencyTotal: {
                    serializedName: "billingCurrencyTotal",
                    type: {
                        name: "Composite",
                        className: "Price"
                    }
                },
                billingAccount: {
                    serializedName: "billingAccount",
                    type: {
                        name: "String"
                    }
                },
                status: {
                    serializedName: "status",
                    type: {
                        name: "String"
                    }
                },
                extendedStatusInfo: {
                    serializedName: "extendedStatusInfo",
                    type: {
                        name: "Composite",
                        className: "ExtendedStatusInfo"
                    }
                }
            }
        }
    };
    var ReservationOrderBillingPlanInformation = {
        serializedName: "ReservationOrderBillingPlanInformation",
        type: {
            name: "Composite",
            className: "ReservationOrderBillingPlanInformation",
            modelProperties: {
                pricingCurrencyTotal: {
                    serializedName: "pricingCurrencyTotal",
                    type: {
                        name: "Composite",
                        className: "Price"
                    }
                },
                startDate: {
                    serializedName: "startDate",
                    type: {
                        name: "Date"
                    }
                },
                nextPaymentDueDate: {
                    serializedName: "nextPaymentDueDate",
                    type: {
                        name: "Date"
                    }
                },
                transactions: {
                    serializedName: "transactions",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "PaymentDetail"
                            }
                        }
                    }
                }
            }
        }
    };
    var ReservationSplitProperties = {
        serializedName: "ReservationSplitProperties",
        type: {
            name: "Composite",
            className: "ReservationSplitProperties",
            modelProperties: {
                splitDestinations: {
                    serializedName: "splitDestinations",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                },
                splitSource: {
                    serializedName: "splitSource",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ReservationMergeProperties = {
        serializedName: "ReservationMergeProperties",
        type: {
            name: "Composite",
            className: "ReservationMergeProperties",
            modelProperties: {
                mergeDestination: {
                    serializedName: "mergeDestination",
                    type: {
                        name: "String"
                    }
                },
                mergeSources: {
                    serializedName: "mergeSources",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                }
            }
        }
    };
    var PurchaseRequestPropertiesReservedResourceProperties = {
        serializedName: "PurchaseRequestProperties_reservedResourceProperties",
        type: {
            name: "Composite",
            className: "PurchaseRequestPropertiesReservedResourceProperties",
            modelProperties: {
                instanceFlexibility: {
                    serializedName: "instanceFlexibility",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var PurchaseRequest = {
        serializedName: "PurchaseRequest",
        type: {
            name: "Composite",
            className: "PurchaseRequest",
            modelProperties: {
                sku: {
                    serializedName: "sku",
                    type: {
                        name: "Composite",
                        className: "SkuName"
                    }
                },
                location: {
                    serializedName: "location",
                    type: {
                        name: "String"
                    }
                },
                reservedResourceType: {
                    serializedName: "properties.reservedResourceType",
                    type: {
                        name: "String"
                    }
                },
                billingScopeId: {
                    serializedName: "properties.billingScopeId",
                    type: {
                        name: "String"
                    }
                },
                term: {
                    serializedName: "properties.term",
                    type: {
                        name: "String"
                    }
                },
                billingPlan: {
                    serializedName: "properties.billingPlan",
                    type: {
                        name: "String"
                    }
                },
                quantity: {
                    serializedName: "properties.quantity",
                    type: {
                        name: "Number"
                    }
                },
                displayName: {
                    serializedName: "properties.displayName",
                    type: {
                        name: "String"
                    }
                },
                appliedScopeType: {
                    serializedName: "properties.appliedScopeType",
                    type: {
                        name: "String"
                    }
                },
                appliedScopes: {
                    serializedName: "properties.appliedScopes",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                },
                renew: {
                    serializedName: "properties.renew",
                    type: {
                        name: "Boolean"
                    }
                },
                reservedResourceProperties: {
                    serializedName: "properties.reservedResourceProperties",
                    type: {
                        name: "Composite",
                        className: "PurchaseRequestPropertiesReservedResourceProperties"
                    }
                }
            }
        }
    };
    var RenewPropertiesResponsePricingCurrencyTotal = {
        serializedName: "RenewPropertiesResponse_pricingCurrencyTotal",
        type: {
            name: "Composite",
            className: "RenewPropertiesResponsePricingCurrencyTotal",
            modelProperties: {
                currencyCode: {
                    serializedName: "currencyCode",
                    type: {
                        name: "String"
                    }
                },
                amount: {
                    serializedName: "amount",
                    type: {
                        name: "Number"
                    }
                }
            }
        }
    };
    var RenewPropertiesResponseBillingCurrencyTotal = {
        serializedName: "RenewPropertiesResponse_billingCurrencyTotal",
        type: {
            name: "Composite",
            className: "RenewPropertiesResponseBillingCurrencyTotal",
            modelProperties: {
                currencyCode: {
                    serializedName: "currencyCode",
                    type: {
                        name: "String"
                    }
                },
                amount: {
                    serializedName: "amount",
                    type: {
                        name: "Number"
                    }
                }
            }
        }
    };
    var RenewPropertiesResponse = {
        serializedName: "RenewPropertiesResponse",
        type: {
            name: "Composite",
            className: "RenewPropertiesResponse",
            modelProperties: {
                purchaseProperties: {
                    serializedName: "purchaseProperties",
                    type: {
                        name: "Composite",
                        className: "PurchaseRequest"
                    }
                },
                pricingCurrencyTotal: {
                    serializedName: "pricingCurrencyTotal",
                    type: {
                        name: "Composite",
                        className: "RenewPropertiesResponsePricingCurrencyTotal"
                    }
                },
                billingCurrencyTotal: {
                    serializedName: "billingCurrencyTotal",
                    type: {
                        name: "Composite",
                        className: "RenewPropertiesResponseBillingCurrencyTotal"
                    }
                }
            }
        }
    };
    var ReservationProperties = {
        serializedName: "ReservationProperties",
        type: {
            name: "Composite",
            className: "ReservationProperties",
            modelProperties: {
                reservedResourceType: {
                    serializedName: "reservedResourceType",
                    type: {
                        name: "String"
                    }
                },
                instanceFlexibility: {
                    serializedName: "instanceFlexibility",
                    type: {
                        name: "String"
                    }
                },
                displayName: {
                    serializedName: "displayName",
                    type: {
                        name: "String"
                    }
                },
                appliedScopes: {
                    serializedName: "appliedScopes",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                },
                appliedScopeType: {
                    serializedName: "appliedScopeType",
                    type: {
                        name: "String"
                    }
                },
                quantity: {
                    serializedName: "quantity",
                    type: {
                        name: "Number"
                    }
                },
                provisioningState: {
                    serializedName: "provisioningState",
                    type: {
                        name: "String"
                    }
                },
                effectiveDateTime: {
                    serializedName: "effectiveDateTime",
                    type: {
                        name: "DateTime"
                    }
                },
                lastUpdatedDateTime: {
                    readOnly: true,
                    serializedName: "lastUpdatedDateTime",
                    type: {
                        name: "DateTime"
                    }
                },
                expiryDate: {
                    serializedName: "expiryDate",
                    type: {
                        name: "Date"
                    }
                },
                skuDescription: {
                    serializedName: "skuDescription",
                    type: {
                        name: "String"
                    }
                },
                extendedStatusInfo: {
                    serializedName: "extendedStatusInfo",
                    type: {
                        name: "Composite",
                        className: "ExtendedStatusInfo"
                    }
                },
                billingPlan: {
                    serializedName: "billingPlan",
                    type: {
                        name: "String"
                    }
                },
                splitProperties: {
                    serializedName: "splitProperties",
                    type: {
                        name: "Composite",
                        className: "ReservationSplitProperties"
                    }
                },
                mergeProperties: {
                    serializedName: "mergeProperties",
                    type: {
                        name: "Composite",
                        className: "ReservationMergeProperties"
                    }
                },
                billingScopeId: {
                    serializedName: "billingScopeId",
                    type: {
                        name: "String"
                    }
                },
                renew: {
                    serializedName: "renew",
                    type: {
                        name: "Boolean"
                    }
                },
                renewSource: {
                    serializedName: "renewSource",
                    type: {
                        name: "String"
                    }
                },
                renewDestination: {
                    serializedName: "renewDestination",
                    type: {
                        name: "String"
                    }
                },
                renewProperties: {
                    serializedName: "renewProperties",
                    type: {
                        name: "Composite",
                        className: "RenewPropertiesResponse"
                    }
                },
                term: {
                    serializedName: "term",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ReservationResponse = {
        serializedName: "ReservationResponse",
        type: {
            name: "Composite",
            className: "ReservationResponse",
            modelProperties: {
                location: {
                    readOnly: true,
                    serializedName: "location",
                    type: {
                        name: "String"
                    }
                },
                etag: {
                    serializedName: "etag",
                    type: {
                        name: "Number"
                    }
                },
                id: {
                    readOnly: true,
                    serializedName: "id",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                sku: {
                    serializedName: "sku",
                    type: {
                        name: "Composite",
                        className: "SkuName"
                    }
                },
                properties: {
                    serializedName: "properties",
                    type: {
                        name: "Composite",
                        className: "ReservationProperties"
                    }
                },
                type: {
                    readOnly: true,
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ReservationOrderResponse = {
        serializedName: "ReservationOrderResponse",
        type: {
            name: "Composite",
            className: "ReservationOrderResponse",
            modelProperties: {
                etag: {
                    serializedName: "etag",
                    type: {
                        name: "Number"
                    }
                },
                id: {
                    readOnly: true,
                    serializedName: "id",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                displayName: {
                    serializedName: "properties.displayName",
                    type: {
                        name: "String"
                    }
                },
                requestDateTime: {
                    serializedName: "properties.requestDateTime",
                    type: {
                        name: "DateTime"
                    }
                },
                createdDateTime: {
                    serializedName: "properties.createdDateTime",
                    type: {
                        name: "DateTime"
                    }
                },
                expiryDate: {
                    serializedName: "properties.expiryDate",
                    type: {
                        name: "Date"
                    }
                },
                originalQuantity: {
                    serializedName: "properties.originalQuantity",
                    type: {
                        name: "Number"
                    }
                },
                term: {
                    serializedName: "properties.term",
                    type: {
                        name: "String"
                    }
                },
                provisioningState: {
                    serializedName: "properties.provisioningState",
                    type: {
                        name: "String"
                    }
                },
                billingPlan: {
                    serializedName: "properties.billingPlan",
                    type: {
                        name: "String"
                    }
                },
                planInformation: {
                    serializedName: "properties.planInformation",
                    type: {
                        name: "Composite",
                        className: "ReservationOrderBillingPlanInformation"
                    }
                },
                reservations: {
                    serializedName: "properties.reservations",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "ReservationResponse"
                            }
                        }
                    }
                },
                type: {
                    readOnly: true,
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var CalculatePriceResponsePropertiesBillingCurrencyTotal = {
        serializedName: "CalculatePriceResponseProperties_billingCurrencyTotal",
        type: {
            name: "Composite",
            className: "CalculatePriceResponsePropertiesBillingCurrencyTotal",
            modelProperties: {
                currencyCode: {
                    serializedName: "currencyCode",
                    type: {
                        name: "String"
                    }
                },
                amount: {
                    serializedName: "amount",
                    type: {
                        name: "Number"
                    }
                }
            }
        }
    };
    var CalculatePriceResponsePropertiesPricingCurrencyTotal = {
        serializedName: "CalculatePriceResponseProperties_pricingCurrencyTotal",
        type: {
            name: "Composite",
            className: "CalculatePriceResponsePropertiesPricingCurrencyTotal",
            modelProperties: {
                currencyCode: {
                    serializedName: "currencyCode",
                    type: {
                        name: "String"
                    }
                },
                amount: {
                    serializedName: "amount",
                    type: {
                        name: "Number"
                    }
                }
            }
        }
    };
    var CalculatePriceResponseProperties = {
        serializedName: "CalculatePriceResponseProperties",
        type: {
            name: "Composite",
            className: "CalculatePriceResponseProperties",
            modelProperties: {
                billingCurrencyTotal: {
                    serializedName: "billingCurrencyTotal",
                    type: {
                        name: "Composite",
                        className: "CalculatePriceResponsePropertiesBillingCurrencyTotal"
                    }
                },
                isBillingPartnerManaged: {
                    serializedName: "isBillingPartnerManaged",
                    type: {
                        name: "Boolean"
                    }
                },
                reservationOrderId: {
                    serializedName: "reservationOrderId",
                    type: {
                        name: "String"
                    }
                },
                skuTitle: {
                    serializedName: "skuTitle",
                    type: {
                        name: "String"
                    }
                },
                skuDescription: {
                    serializedName: "skuDescription",
                    type: {
                        name: "String"
                    }
                },
                pricingCurrencyTotal: {
                    serializedName: "pricingCurrencyTotal",
                    type: {
                        name: "Composite",
                        className: "CalculatePriceResponsePropertiesPricingCurrencyTotal"
                    }
                },
                paymentSchedule: {
                    serializedName: "paymentSchedule",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "PaymentDetail"
                            }
                        }
                    }
                }
            }
        }
    };
    var CalculatePriceResponse = {
        serializedName: "CalculatePriceResponse",
        type: {
            name: "Composite",
            className: "CalculatePriceResponse",
            modelProperties: {
                properties: {
                    serializedName: "properties",
                    type: {
                        name: "Composite",
                        className: "CalculatePriceResponseProperties"
                    }
                }
            }
        }
    };
    var PatchPropertiesRenewProperties = {
        serializedName: "PatchProperties_renewProperties",
        type: {
            name: "Composite",
            className: "PatchPropertiesRenewProperties",
            modelProperties: {
                purchaseProperties: {
                    serializedName: "purchaseProperties",
                    type: {
                        name: "Composite",
                        className: "PurchaseRequest"
                    }
                }
            }
        }
    };
    var MergeRequest = {
        serializedName: "MergeRequest",
        type: {
            name: "Composite",
            className: "MergeRequest",
            modelProperties: {
                sources: {
                    serializedName: "properties.sources",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                }
            }
        }
    };
    var Patch = {
        serializedName: "Patch",
        type: {
            name: "Composite",
            className: "Patch",
            modelProperties: {
                appliedScopeType: {
                    serializedName: "properties.appliedScopeType",
                    type: {
                        name: "String"
                    }
                },
                appliedScopes: {
                    serializedName: "properties.appliedScopes",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                },
                instanceFlexibility: {
                    serializedName: "properties.instanceFlexibility",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    serializedName: "properties.name",
                    type: {
                        name: "String"
                    }
                },
                renew: {
                    serializedName: "properties.renew",
                    type: {
                        name: "Boolean"
                    }
                },
                renewProperties: {
                    serializedName: "properties.renewProperties",
                    type: {
                        name: "Composite",
                        className: "PatchPropertiesRenewProperties"
                    }
                }
            }
        }
    };
    var SplitRequest = {
        serializedName: "SplitRequest",
        type: {
            name: "Composite",
            className: "SplitRequest",
            modelProperties: {
                quantities: {
                    serializedName: "properties.quantities",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Number"
                            }
                        }
                    }
                },
                reservationId: {
                    serializedName: "properties.reservationId",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ExtendedErrorInfo = {
        serializedName: "ExtendedErrorInfo",
        type: {
            name: "Composite",
            className: "ExtendedErrorInfo",
            modelProperties: {
                code: {
                    serializedName: "code",
                    type: {
                        name: "String"
                    }
                },
                message: {
                    serializedName: "message",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ErrorModel = {
        serializedName: "Error",
        type: {
            name: "Composite",
            className: "ErrorModel",
            modelProperties: {
                error: {
                    serializedName: "error",
                    type: {
                        name: "Composite",
                        className: "ExtendedErrorInfo"
                    }
                }
            }
        }
    };
    var AppliedReservationList = {
        serializedName: "AppliedReservationList",
        type: {
            name: "Composite",
            className: "AppliedReservationList",
            modelProperties: {
                value: {
                    serializedName: "value",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "String"
                            }
                        }
                    }
                },
                nextLink: {
                    serializedName: "nextLink",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var AppliedReservations = {
        serializedName: "AppliedReservations",
        type: {
            name: "Composite",
            className: "AppliedReservations",
            modelProperties: {
                id: {
                    readOnly: true,
                    serializedName: "id",
                    type: {
                        name: "String"
                    }
                },
                name: {
                    readOnly: true,
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                type: {
                    readOnly: true,
                    serializedName: "type",
                    type: {
                        name: "String"
                    }
                },
                reservationOrderIds: {
                    serializedName: "properties.reservationOrderIds",
                    type: {
                        name: "Composite",
                        className: "AppliedReservationList"
                    }
                }
            }
        }
    };
    var OperationDisplay = {
        serializedName: "OperationDisplay",
        type: {
            name: "Composite",
            className: "OperationDisplay",
            modelProperties: {
                provider: {
                    serializedName: "provider",
                    type: {
                        name: "String"
                    }
                },
                resource: {
                    serializedName: "resource",
                    type: {
                        name: "String"
                    }
                },
                operation: {
                    serializedName: "operation",
                    type: {
                        name: "String"
                    }
                },
                description: {
                    serializedName: "description",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var OperationResponse = {
        serializedName: "OperationResponse",
        type: {
            name: "Composite",
            className: "OperationResponse",
            modelProperties: {
                name: {
                    serializedName: "name",
                    type: {
                        name: "String"
                    }
                },
                display: {
                    serializedName: "display",
                    type: {
                        name: "Composite",
                        className: "OperationDisplay"
                    }
                },
                origin: {
                    serializedName: "origin",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ScopeProperties = {
        serializedName: "ScopeProperties",
        type: {
            name: "Composite",
            className: "ScopeProperties",
            modelProperties: {
                scope: {
                    serializedName: "scope",
                    type: {
                        name: "String"
                    }
                },
                valid: {
                    serializedName: "valid",
                    type: {
                        name: "Boolean"
                    }
                }
            }
        }
    };
    var SubscriptionScopeProperties = {
        serializedName: "SubscriptionScopeProperties",
        type: {
            name: "Composite",
            className: "SubscriptionScopeProperties",
            modelProperties: {
                scopes: {
                    serializedName: "scopes",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "ScopeProperties"
                            }
                        }
                    }
                }
            }
        }
    };
    var Properties = {
        serializedName: "Properties",
        type: {
            name: "Composite",
            className: "Properties",
            modelProperties: {
                properties: {
                    serializedName: "properties",
                    type: {
                        name: "Composite",
                        className: "SubscriptionScopeProperties"
                    }
                }
            }
        }
    };
    var QuotaGetHeaders = {
        serializedName: "quota-get-headers",
        type: {
            name: "Composite",
            className: "QuotaGetHeaders",
            modelProperties: {
                eTag: {
                    serializedName: "etag",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var QuotaListHeaders = {
        serializedName: "quota-list-headers",
        type: {
            name: "Composite",
            className: "QuotaListHeaders",
            modelProperties: {
                eTag: {
                    serializedName: "etag",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var QuotaLimits = {
        serializedName: "QuotaLimits",
        type: {
            name: "Composite",
            className: "QuotaLimits",
            modelProperties: {
                value: {
                    serializedName: "",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "CurrentQuotaLimitBase"
                            }
                        }
                    }
                },
                nextLink: {
                    serializedName: "nextLink",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var QuotaRequestDetailsList = {
        serializedName: "QuotaRequestDetailsList",
        type: {
            name: "Composite",
            className: "QuotaRequestDetailsList",
            modelProperties: {
                value: {
                    serializedName: "",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "QuotaRequestDetails"
                            }
                        }
                    }
                },
                nextLink: {
                    serializedName: "nextLink",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ReservationList = {
        serializedName: "ReservationList",
        type: {
            name: "Composite",
            className: "ReservationList",
            modelProperties: {
                value: {
                    serializedName: "",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "ReservationResponse"
                            }
                        }
                    }
                },
                nextLink: {
                    serializedName: "nextLink",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var ReservationOrderList = {
        serializedName: "ReservationOrderList",
        type: {
            name: "Composite",
            className: "ReservationOrderList",
            modelProperties: {
                value: {
                    serializedName: "",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "ReservationOrderResponse"
                            }
                        }
                    }
                },
                nextLink: {
                    serializedName: "nextLink",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };
    var OperationList = {
        serializedName: "OperationList",
        type: {
            name: "Composite",
            className: "OperationList",
            modelProperties: {
                value: {
                    serializedName: "",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "OperationResponse"
                            }
                        }
                    }
                },
                nextLink: {
                    serializedName: "nextLink",
                    type: {
                        name: "String"
                    }
                }
            }
        }
    };

    var Mappers = /*#__PURE__*/Object.freeze({
        __proto__: null,
        CloudError: CloudError,
        BaseResource: BaseResource,
        ResourceName: ResourceName,
        QuotaProperties: QuotaProperties,
        CurrentQuotaLimitBase: CurrentQuotaLimitBase,
        CurrentQuotaLimit: CurrentQuotaLimit,
        QuotaLimitsResponse: QuotaLimitsResponse,
        CreateGenericQuotaRequestParameters: CreateGenericQuotaRequestParameters,
        SubRequest: SubRequest,
        QuotaRequestOneResourceSubmitResponse: QuotaRequestOneResourceSubmitResponse,
        QuotaRequestProperties: QuotaRequestProperties,
        QuotaRequestSubmitResponse: QuotaRequestSubmitResponse,
        QuotaRequestSubmitResponse201: QuotaRequestSubmitResponse201,
        QuotaRequestDetails: QuotaRequestDetails,
        AqiSettings: AqiSettings,
        EmailAction: EmailAction,
        EmailActions: EmailActions,
        Actions: Actions,
        SupportRequestAction: SupportRequestAction,
        AutoQuotaIncreaseDetail: AutoQuotaIncreaseDetail,
        PhoneAction: PhoneAction,
        ServiceErrorDetail: ServiceErrorDetail,
        ServiceError: ServiceError,
        ExceptionResponse: ExceptionResponse,
        SkuName: SkuName,
        SkuProperty: SkuProperty,
        SkuRestriction: SkuRestriction,
        Catalog: Catalog,
        Price: Price,
        ExtendedStatusInfo: ExtendedStatusInfo,
        PaymentDetail: PaymentDetail,
        ReservationOrderBillingPlanInformation: ReservationOrderBillingPlanInformation,
        ReservationSplitProperties: ReservationSplitProperties,
        ReservationMergeProperties: ReservationMergeProperties,
        PurchaseRequestPropertiesReservedResourceProperties: PurchaseRequestPropertiesReservedResourceProperties,
        PurchaseRequest: PurchaseRequest,
        RenewPropertiesResponsePricingCurrencyTotal: RenewPropertiesResponsePricingCurrencyTotal,
        RenewPropertiesResponseBillingCurrencyTotal: RenewPropertiesResponseBillingCurrencyTotal,
        RenewPropertiesResponse: RenewPropertiesResponse,
        ReservationProperties: ReservationProperties,
        ReservationResponse: ReservationResponse,
        ReservationOrderResponse: ReservationOrderResponse,
        CalculatePriceResponsePropertiesBillingCurrencyTotal: CalculatePriceResponsePropertiesBillingCurrencyTotal,
        CalculatePriceResponsePropertiesPricingCurrencyTotal: CalculatePriceResponsePropertiesPricingCurrencyTotal,
        CalculatePriceResponseProperties: CalculatePriceResponseProperties,
        CalculatePriceResponse: CalculatePriceResponse,
        PatchPropertiesRenewProperties: PatchPropertiesRenewProperties,
        MergeRequest: MergeRequest,
        Patch: Patch,
        SplitRequest: SplitRequest,
        ExtendedErrorInfo: ExtendedErrorInfo,
        ErrorModel: ErrorModel,
        AppliedReservationList: AppliedReservationList,
        AppliedReservations: AppliedReservations,
        OperationDisplay: OperationDisplay,
        OperationResponse: OperationResponse,
        ScopeProperties: ScopeProperties,
        SubscriptionScopeProperties: SubscriptionScopeProperties,
        Properties: Properties,
        QuotaGetHeaders: QuotaGetHeaders,
        QuotaListHeaders: QuotaListHeaders,
        QuotaLimits: QuotaLimits,
        QuotaRequestDetailsList: QuotaRequestDetailsList,
        ReservationList: ReservationList,
        ReservationOrderList: ReservationOrderList,
        OperationList: OperationList
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    var acceptLanguage = {
        parameterPath: "acceptLanguage",
        mapper: {
            serializedName: "accept-language",
            defaultValue: 'en-US',
            type: {
                name: "String"
            }
        }
    };
    var apiVersion0 = {
        parameterPath: "apiVersion",
        mapper: {
            required: true,
            isConstant: true,
            serializedName: "api-version",
            defaultValue: '2019-07-19-preview',
            type: {
                name: "String"
            }
        }
    };
    var apiVersion1 = {
        parameterPath: "apiVersion",
        mapper: {
            required: true,
            isConstant: true,
            serializedName: "api-version",
            defaultValue: '2019-04-01',
            type: {
                name: "String"
            }
        }
    };
    var expand0 = {
        parameterPath: [
            "options",
            "expand"
        ],
        mapper: {
            serializedName: "expand",
            type: {
                name: "String"
            }
        }
    };
    var expand1 = {
        parameterPath: [
            "options",
            "expand"
        ],
        mapper: {
            serializedName: "$expand",
            type: {
                name: "String"
            }
        }
    };
    var filter = {
        parameterPath: [
            "options",
            "filter"
        ],
        mapper: {
            serializedName: "$filter",
            type: {
                name: "String"
            }
        }
    };
    var id = {
        parameterPath: "id",
        mapper: {
            required: true,
            serializedName: "id",
            type: {
                name: "String"
            }
        }
    };
    var location0 = {
        parameterPath: "location",
        mapper: {
            required: true,
            serializedName: "location",
            type: {
                name: "String"
            }
        }
    };
    var location1 = {
        parameterPath: [
            "options",
            "location"
        ],
        mapper: {
            serializedName: "location",
            type: {
                name: "String"
            }
        }
    };
    var nextPageLink = {
        parameterPath: "nextPageLink",
        mapper: {
            required: true,
            serializedName: "nextLink",
            type: {
                name: "String"
            }
        },
        skipEncoding: true
    };
    var providerId = {
        parameterPath: "providerId",
        mapper: {
            required: true,
            serializedName: "providerId",
            type: {
                name: "String"
            }
        }
    };
    var reservationId = {
        parameterPath: "reservationId",
        mapper: {
            required: true,
            serializedName: "reservationId",
            type: {
                name: "String"
            }
        }
    };
    var reservationOrderId = {
        parameterPath: "reservationOrderId",
        mapper: {
            required: true,
            serializedName: "reservationOrderId",
            type: {
                name: "String"
            }
        }
    };
    var reservedResourceType = {
        parameterPath: "reservedResourceType",
        mapper: {
            required: true,
            serializedName: "reservedResourceType",
            type: {
                name: "String"
            }
        }
    };
    var resourceName = {
        parameterPath: "resourceName",
        mapper: {
            required: true,
            serializedName: "resourceName",
            type: {
                name: "String"
            }
        }
    };
    var skiptoken = {
        parameterPath: [
            "options",
            "skiptoken"
        ],
        mapper: {
            serializedName: "$skiptoken",
            type: {
                name: "String"
            }
        }
    };
    var subscriptionId = {
        parameterPath: "subscriptionId",
        mapper: {
            required: true,
            serializedName: "subscriptionId",
            type: {
                name: "String"
            }
        }
    };
    var top = {
        parameterPath: [
            "options",
            "top"
        ],
        mapper: {
            serializedName: "$top",
            constraints: {
                InclusiveMinimum: 1
            },
            type: {
                name: "Number"
            }
        }
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var Mappers$1 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        Actions: Actions,
        AqiSettings: AqiSettings,
        AutoQuotaIncreaseDetail: AutoQuotaIncreaseDetail,
        BaseResource: BaseResource,
        CurrentQuotaLimit: CurrentQuotaLimit,
        CurrentQuotaLimitBase: CurrentQuotaLimitBase,
        EmailAction: EmailAction,
        EmailActions: EmailActions,
        ExceptionResponse: ExceptionResponse,
        ExtendedStatusInfo: ExtendedStatusInfo,
        PaymentDetail: PaymentDetail,
        Price: Price,
        PurchaseRequest: PurchaseRequest,
        PurchaseRequestPropertiesReservedResourceProperties: PurchaseRequestPropertiesReservedResourceProperties,
        QuotaGetHeaders: QuotaGetHeaders,
        QuotaLimits: QuotaLimits,
        QuotaListHeaders: QuotaListHeaders,
        QuotaProperties: QuotaProperties,
        QuotaRequestDetails: QuotaRequestDetails,
        QuotaRequestOneResourceSubmitResponse: QuotaRequestOneResourceSubmitResponse,
        QuotaRequestProperties: QuotaRequestProperties,
        QuotaRequestSubmitResponse: QuotaRequestSubmitResponse,
        QuotaRequestSubmitResponse201: QuotaRequestSubmitResponse201,
        RenewPropertiesResponse: RenewPropertiesResponse,
        RenewPropertiesResponseBillingCurrencyTotal: RenewPropertiesResponseBillingCurrencyTotal,
        RenewPropertiesResponsePricingCurrencyTotal: RenewPropertiesResponsePricingCurrencyTotal,
        ReservationMergeProperties: ReservationMergeProperties,
        ReservationOrderBillingPlanInformation: ReservationOrderBillingPlanInformation,
        ReservationOrderResponse: ReservationOrderResponse,
        ReservationProperties: ReservationProperties,
        ReservationResponse: ReservationResponse,
        ReservationSplitProperties: ReservationSplitProperties,
        ResourceName: ResourceName,
        ServiceError: ServiceError,
        ServiceErrorDetail: ServiceErrorDetail,
        SkuName: SkuName,
        SubRequest: SubRequest,
        SupportRequestAction: SupportRequestAction
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    /** Class representing a Quota. */
    var Quota = /** @class */ (function () {
        /**
         * Create a Quota.
         * @param {AzureReservationAPIContext} client Reference to the service client.
         */
        function Quota(client) {
            this.client = client;
        }
        Quota.prototype.get = function (subscriptionId, providerId, location, resourceName, options, callback) {
            return this.client.sendOperationRequest({
                subscriptionId: subscriptionId,
                providerId: providerId,
                location: location,
                resourceName: resourceName,
                options: options
            }, getOperationSpec, callback);
        };
        /**
         * Create or update the service limits (quota) of a resource to requested value.
         * Steps:
         *
         * 1. Make the Get request to get the quota information for specific resource.
         *
         * 2. To increase the quota, update the limit field in the response from Get request to new value.
         *
         * 3. Submit the JSON to the quota request API to update the quota.
         * The Create quota request may be constructed as follows. The PUT operation can be used to update
         * the quota.
         * @param subscriptionId Azure subscription id.
         * @param providerId Azure resource provider id.
         * @param location Azure region.
         * @param resourceName The resource name for a resource provider, such as SKU name for
         * Microsoft.Compute, Sku or TotalLowPriorityCores for Microsoft.MachineLearningServices
         * @param createQuotaRequest Quota requests payload.
         * @param [options] The optional parameters
         * @returns Promise<Models.QuotaCreateOrUpdateResponse>
         */
        Quota.prototype.createOrUpdate = function (subscriptionId, providerId, location, resourceName, createQuotaRequest, options) {
            return this.beginCreateOrUpdate(subscriptionId, providerId, location, resourceName, createQuotaRequest, options)
                .then(function (lroPoller) { return lroPoller.pollUntilFinished(); });
        };
        /**
         * Update the service limits (quota) of a resource to requested value.
         * Steps:
         *
         * 1. Make the Get request to get the quota information for specific resource.
         *
         * 2. To increase the quota, update the limit field in the response from Get request to new value.
         *
         * 3. Submit the JSON to the quota request API to update the quota.
         * The Update quota request may be constructed as follows. The PATCH operation can be used to
         * update the quota.
         * @param subscriptionId Azure subscription id.
         * @param providerId Azure resource provider id.
         * @param location Azure region.
         * @param resourceName The resource name for a resource provider, such as SKU name for
         * Microsoft.Compute, Sku or TotalLowPriorityCores for Microsoft.MachineLearningServices
         * @param createQuotaRequest Quota requests payload.
         * @param [options] The optional parameters
         * @returns Promise<Models.QuotaUpdateResponse>
         */
        Quota.prototype.update = function (subscriptionId, providerId, location, resourceName, createQuotaRequest, options) {
            return this.beginUpdate(subscriptionId, providerId, location, resourceName, createQuotaRequest, options)
                .then(function (lroPoller) { return lroPoller.pollUntilFinished(); });
        };
        Quota.prototype.list = function (subscriptionId, providerId, location, options, callback) {
            return this.client.sendOperationRequest({
                subscriptionId: subscriptionId,
                providerId: providerId,
                location: location,
                options: options
            }, listOperationSpec, callback);
        };
        /**
         * Create or update the service limits (quota) of a resource to requested value.
         * Steps:
         *
         * 1. Make the Get request to get the quota information for specific resource.
         *
         * 2. To increase the quota, update the limit field in the response from Get request to new value.
         *
         * 3. Submit the JSON to the quota request API to update the quota.
         * The Create quota request may be constructed as follows. The PUT operation can be used to update
         * the quota.
         * @param subscriptionId Azure subscription id.
         * @param providerId Azure resource provider id.
         * @param location Azure region.
         * @param resourceName The resource name for a resource provider, such as SKU name for
         * Microsoft.Compute, Sku or TotalLowPriorityCores for Microsoft.MachineLearningServices
         * @param createQuotaRequest Quota requests payload.
         * @param [options] The optional parameters
         * @returns Promise<msRestAzure.LROPoller>
         */
        Quota.prototype.beginCreateOrUpdate = function (subscriptionId, providerId, location, resourceName, createQuotaRequest, options) {
            return this.client.sendLRORequest({
                subscriptionId: subscriptionId,
                providerId: providerId,
                location: location,
                resourceName: resourceName,
                createQuotaRequest: createQuotaRequest,
                options: options
            }, beginCreateOrUpdateOperationSpec, options);
        };
        /**
         * Update the service limits (quota) of a resource to requested value.
         * Steps:
         *
         * 1. Make the Get request to get the quota information for specific resource.
         *
         * 2. To increase the quota, update the limit field in the response from Get request to new value.
         *
         * 3. Submit the JSON to the quota request API to update the quota.
         * The Update quota request may be constructed as follows. The PATCH operation can be used to
         * update the quota.
         * @param subscriptionId Azure subscription id.
         * @param providerId Azure resource provider id.
         * @param location Azure region.
         * @param resourceName The resource name for a resource provider, such as SKU name for
         * Microsoft.Compute, Sku or TotalLowPriorityCores for Microsoft.MachineLearningServices
         * @param createQuotaRequest Quota requests payload.
         * @param [options] The optional parameters
         * @returns Promise<msRestAzure.LROPoller>
         */
        Quota.prototype.beginUpdate = function (subscriptionId, providerId, location, resourceName, createQuotaRequest, options) {
            return this.client.sendLRORequest({
                subscriptionId: subscriptionId,
                providerId: providerId,
                location: location,
                resourceName: resourceName,
                createQuotaRequest: createQuotaRequest,
                options: options
            }, beginUpdateOperationSpec, options);
        };
        Quota.prototype.listNext = function (nextPageLink, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink,
                options: options
            }, listNextOperationSpec, callback);
        };
        return Quota;
    }());
    // Operation Specifications
    var serializer = new msRest.Serializer(Mappers$1);
    var getOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/resourceProviders/{providerId}/locations/{location}/serviceLimits/{resourceName}",
        urlParameters: [
            subscriptionId,
            providerId,
            location0,
            resourceName
        ],
        queryParameters: [
            apiVersion0
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: CurrentQuotaLimitBase,
                headersMapper: QuotaGetHeaders
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer
    };
    var listOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/resourceProviders/{providerId}/locations/{location}/serviceLimits",
        urlParameters: [
            subscriptionId,
            providerId,
            location0
        ],
        queryParameters: [
            apiVersion0
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: QuotaLimits,
                headersMapper: QuotaListHeaders
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer
    };
    var beginCreateOrUpdateOperationSpec = {
        httpMethod: "PUT",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/resourceProviders/{providerId}/locations/{location}/serviceLimits/{resourceName}",
        urlParameters: [
            subscriptionId,
            providerId,
            location0,
            resourceName
        ],
        queryParameters: [
            apiVersion0
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "createQuotaRequest",
            mapper: __assign(__assign({}, CurrentQuotaLimitBase), { required: true })
        },
        responses: {
            200: {
                bodyMapper: QuotaRequestOneResourceSubmitResponse
            },
            201: {
                bodyMapper: QuotaRequestSubmitResponse201
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer
    };
    var beginUpdateOperationSpec = {
        httpMethod: "PATCH",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/resourceProviders/{providerId}/locations/{location}/serviceLimits/{resourceName}",
        urlParameters: [
            subscriptionId,
            providerId,
            location0,
            resourceName
        ],
        queryParameters: [
            apiVersion0
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "createQuotaRequest",
            mapper: __assign(__assign({}, CurrentQuotaLimitBase), { required: true })
        },
        responses: {
            200: {
                bodyMapper: QuotaRequestOneResourceSubmitResponse
            },
            201: {
                bodyMapper: QuotaRequestSubmitResponse201
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer
    };
    var listNextOperationSpec = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: QuotaLimits,
                headersMapper: QuotaListHeaders
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var Mappers$2 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        Actions: Actions,
        AqiSettings: AqiSettings,
        AutoQuotaIncreaseDetail: AutoQuotaIncreaseDetail,
        BaseResource: BaseResource,
        CurrentQuotaLimit: CurrentQuotaLimit,
        CurrentQuotaLimitBase: CurrentQuotaLimitBase,
        EmailAction: EmailAction,
        EmailActions: EmailActions,
        ExceptionResponse: ExceptionResponse,
        ExtendedStatusInfo: ExtendedStatusInfo,
        PaymentDetail: PaymentDetail,
        Price: Price,
        PurchaseRequest: PurchaseRequest,
        PurchaseRequestPropertiesReservedResourceProperties: PurchaseRequestPropertiesReservedResourceProperties,
        QuotaProperties: QuotaProperties,
        QuotaRequestDetails: QuotaRequestDetails,
        QuotaRequestDetailsList: QuotaRequestDetailsList,
        QuotaRequestOneResourceSubmitResponse: QuotaRequestOneResourceSubmitResponse,
        QuotaRequestProperties: QuotaRequestProperties,
        QuotaRequestSubmitResponse: QuotaRequestSubmitResponse,
        RenewPropertiesResponse: RenewPropertiesResponse,
        RenewPropertiesResponseBillingCurrencyTotal: RenewPropertiesResponseBillingCurrencyTotal,
        RenewPropertiesResponsePricingCurrencyTotal: RenewPropertiesResponsePricingCurrencyTotal,
        ReservationMergeProperties: ReservationMergeProperties,
        ReservationOrderBillingPlanInformation: ReservationOrderBillingPlanInformation,
        ReservationOrderResponse: ReservationOrderResponse,
        ReservationProperties: ReservationProperties,
        ReservationResponse: ReservationResponse,
        ReservationSplitProperties: ReservationSplitProperties,
        ResourceName: ResourceName,
        ServiceError: ServiceError,
        ServiceErrorDetail: ServiceErrorDetail,
        SkuName: SkuName,
        SubRequest: SubRequest,
        SupportRequestAction: SupportRequestAction
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    /** Class representing a QuotaRequestStatus. */
    var QuotaRequestStatus = /** @class */ (function () {
        /**
         * Create a QuotaRequestStatus.
         * @param {AzureReservationAPIContext} client Reference to the service client.
         */
        function QuotaRequestStatus(client) {
            this.client = client;
        }
        QuotaRequestStatus.prototype.get = function (subscriptionId, providerId, location, id, options, callback) {
            return this.client.sendOperationRequest({
                subscriptionId: subscriptionId,
                providerId: providerId,
                location: location,
                id: id,
                options: options
            }, getOperationSpec$1, callback);
        };
        QuotaRequestStatus.prototype.list = function (subscriptionId, providerId, location, options, callback) {
            return this.client.sendOperationRequest({
                subscriptionId: subscriptionId,
                providerId: providerId,
                location: location,
                options: options
            }, listOperationSpec$1, callback);
        };
        QuotaRequestStatus.prototype.listNext = function (nextPageLink, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink,
                options: options
            }, listNextOperationSpec$1, callback);
        };
        return QuotaRequestStatus;
    }());
    // Operation Specifications
    var serializer$1 = new msRest.Serializer(Mappers$2);
    var getOperationSpec$1 = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/resourceProviders/{providerId}/locations/{location}/serviceLimitsRequests/{id}",
        urlParameters: [
            subscriptionId,
            providerId,
            location0,
            id
        ],
        queryParameters: [
            apiVersion0
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: QuotaRequestDetails
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer$1
    };
    var listOperationSpec$1 = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/resourceProviders/{providerId}/locations/{location}/serviceLimitsRequests",
        urlParameters: [
            subscriptionId,
            providerId,
            location0
        ],
        queryParameters: [
            apiVersion0,
            filter,
            top,
            skiptoken
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: QuotaRequestDetailsList
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer$1
    };
    var listNextOperationSpec$1 = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: QuotaRequestDetailsList
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer$1
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var Mappers$3 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        Actions: Actions,
        AqiSettings: AqiSettings,
        AutoQuotaIncreaseDetail: AutoQuotaIncreaseDetail,
        BaseResource: BaseResource,
        CurrentQuotaLimit: CurrentQuotaLimit,
        CurrentQuotaLimitBase: CurrentQuotaLimitBase,
        EmailAction: EmailAction,
        EmailActions: EmailActions,
        ExceptionResponse: ExceptionResponse,
        ExtendedStatusInfo: ExtendedStatusInfo,
        PaymentDetail: PaymentDetail,
        Price: Price,
        PurchaseRequest: PurchaseRequest,
        PurchaseRequestPropertiesReservedResourceProperties: PurchaseRequestPropertiesReservedResourceProperties,
        QuotaProperties: QuotaProperties,
        QuotaRequestDetails: QuotaRequestDetails,
        QuotaRequestOneResourceSubmitResponse: QuotaRequestOneResourceSubmitResponse,
        QuotaRequestProperties: QuotaRequestProperties,
        QuotaRequestSubmitResponse: QuotaRequestSubmitResponse,
        RenewPropertiesResponse: RenewPropertiesResponse,
        RenewPropertiesResponseBillingCurrencyTotal: RenewPropertiesResponseBillingCurrencyTotal,
        RenewPropertiesResponsePricingCurrencyTotal: RenewPropertiesResponsePricingCurrencyTotal,
        ReservationMergeProperties: ReservationMergeProperties,
        ReservationOrderBillingPlanInformation: ReservationOrderBillingPlanInformation,
        ReservationOrderResponse: ReservationOrderResponse,
        ReservationProperties: ReservationProperties,
        ReservationResponse: ReservationResponse,
        ReservationSplitProperties: ReservationSplitProperties,
        ResourceName: ResourceName,
        ServiceError: ServiceError,
        ServiceErrorDetail: ServiceErrorDetail,
        SkuName: SkuName,
        SubRequest: SubRequest,
        SupportRequestAction: SupportRequestAction
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    /** Class representing a AutoQuotaIncrease. */
    var AutoQuotaIncrease = /** @class */ (function () {
        /**
         * Create a AutoQuotaIncrease.
         * @param {AzureReservationAPIContext} client Reference to the service client.
         */
        function AutoQuotaIncrease(client) {
            this.client = client;
        }
        AutoQuotaIncrease.prototype.getProperties = function (subscriptionId, options, callback) {
            return this.client.sendOperationRequest({
                subscriptionId: subscriptionId,
                options: options
            }, getPropertiesOperationSpec, callback);
        };
        AutoQuotaIncrease.prototype.create = function (subscriptionId, autoQuotaIncreaseRequest, options, callback) {
            return this.client.sendOperationRequest({
                subscriptionId: subscriptionId,
                autoQuotaIncreaseRequest: autoQuotaIncreaseRequest,
                options: options
            }, createOperationSpec, callback);
        };
        return AutoQuotaIncrease;
    }());
    // Operation Specifications
    var serializer$2 = new msRest.Serializer(Mappers$3);
    var getPropertiesOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/autoQuotaIncrease",
        urlParameters: [
            subscriptionId
        ],
        queryParameters: [
            apiVersion0
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: AutoQuotaIncreaseDetail
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer$2
    };
    var createOperationSpec = {
        httpMethod: "PUT",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/autoQuotaIncrease",
        urlParameters: [
            subscriptionId
        ],
        queryParameters: [
            apiVersion0
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "autoQuotaIncreaseRequest",
            mapper: __assign(__assign({}, AutoQuotaIncreaseDetail), { required: true })
        },
        responses: {
            200: {
                bodyMapper: AutoQuotaIncreaseDetail
            },
            default: {
                bodyMapper: ExceptionResponse
            }
        },
        serializer: serializer$2
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var Mappers$4 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        Actions: Actions,
        AqiSettings: AqiSettings,
        AutoQuotaIncreaseDetail: AutoQuotaIncreaseDetail,
        BaseResource: BaseResource,
        CurrentQuotaLimit: CurrentQuotaLimit,
        CurrentQuotaLimitBase: CurrentQuotaLimitBase,
        EmailAction: EmailAction,
        EmailActions: EmailActions,
        ErrorModel: ErrorModel,
        ExtendedErrorInfo: ExtendedErrorInfo,
        ExtendedStatusInfo: ExtendedStatusInfo,
        MergeRequest: MergeRequest,
        Patch: Patch,
        PatchPropertiesRenewProperties: PatchPropertiesRenewProperties,
        PaymentDetail: PaymentDetail,
        Price: Price,
        Properties: Properties,
        PurchaseRequest: PurchaseRequest,
        PurchaseRequestPropertiesReservedResourceProperties: PurchaseRequestPropertiesReservedResourceProperties,
        QuotaProperties: QuotaProperties,
        QuotaRequestDetails: QuotaRequestDetails,
        QuotaRequestOneResourceSubmitResponse: QuotaRequestOneResourceSubmitResponse,
        QuotaRequestProperties: QuotaRequestProperties,
        QuotaRequestSubmitResponse: QuotaRequestSubmitResponse,
        RenewPropertiesResponse: RenewPropertiesResponse,
        RenewPropertiesResponseBillingCurrencyTotal: RenewPropertiesResponseBillingCurrencyTotal,
        RenewPropertiesResponsePricingCurrencyTotal: RenewPropertiesResponsePricingCurrencyTotal,
        ReservationList: ReservationList,
        ReservationMergeProperties: ReservationMergeProperties,
        ReservationOrderBillingPlanInformation: ReservationOrderBillingPlanInformation,
        ReservationOrderResponse: ReservationOrderResponse,
        ReservationProperties: ReservationProperties,
        ReservationResponse: ReservationResponse,
        ReservationSplitProperties: ReservationSplitProperties,
        ResourceName: ResourceName,
        ScopeProperties: ScopeProperties,
        SkuName: SkuName,
        SplitRequest: SplitRequest,
        SubRequest: SubRequest,
        SubscriptionScopeProperties: SubscriptionScopeProperties,
        SupportRequestAction: SupportRequestAction
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    /** Class representing a Reservation. */
    var Reservation = /** @class */ (function () {
        /**
         * Create a Reservation.
         * @param {AzureReservationAPIContext} client Reference to the service client.
         */
        function Reservation(client) {
            this.client = client;
        }
        /**
         * Get Available Scopes for `Reservation`.
         * @summary Get Available Scopes for `Reservation`.
         * @param reservationOrderId Order Id of the reservation
         * @param reservationId Id of the Reservation Item
         * @param body
         * @param [options] The optional parameters
         * @returns Promise<Models.ReservationAvailableScopesResponse>
         */
        Reservation.prototype.availableScopes = function (reservationOrderId, reservationId, body, options) {
            return this.beginAvailableScopes(reservationOrderId, reservationId, body, options)
                .then(function (lroPoller) { return lroPoller.pollUntilFinished(); });
        };
        /**
         * Split a `Reservation` into two `Reservation`s with specified quantity distribution.
         * @summary Split the `Reservation`.
         * @param reservationOrderId Order Id of the reservation
         * @param body Information needed to Split a reservation item
         * @param [options] The optional parameters
         * @returns Promise<Models.ReservationSplitResponse>
         */
        Reservation.prototype.split = function (reservationOrderId, body, options) {
            return this.beginSplit(reservationOrderId, body, options)
                .then(function (lroPoller) { return lroPoller.pollUntilFinished(); });
        };
        /**
         * Merge the specified `Reservation`s into a new `Reservation`. The two `Reservation`s being merged
         * must have same properties.
         * @summary Merges two `Reservation`s.
         * @param reservationOrderId Order Id of the reservation
         * @param body Information needed for commercial request for a reservation
         * @param [options] The optional parameters
         * @returns Promise<Models.ReservationMergeResponse>
         */
        Reservation.prototype.merge = function (reservationOrderId, body, options) {
            return this.beginMerge(reservationOrderId, body, options)
                .then(function (lroPoller) { return lroPoller.pollUntilFinished(); });
        };
        Reservation.prototype.list = function (reservationOrderId, options, callback) {
            return this.client.sendOperationRequest({
                reservationOrderId: reservationOrderId,
                options: options
            }, listOperationSpec$2, callback);
        };
        Reservation.prototype.get = function (reservationId, reservationOrderId, options, callback) {
            return this.client.sendOperationRequest({
                reservationId: reservationId,
                reservationOrderId: reservationOrderId,
                options: options
            }, getOperationSpec$2, callback);
        };
        /**
         * Updates the applied scopes of the `Reservation`.
         * @summary Updates a `Reservation`.
         * @param reservationOrderId Order Id of the reservation
         * @param reservationId Id of the Reservation Item
         * @param parameters Information needed to patch a reservation item
         * @param [options] The optional parameters
         * @returns Promise<Models.ReservationUpdateResponse>
         */
        Reservation.prototype.update = function (reservationOrderId, reservationId, parameters, options) {
            return this.beginUpdate(reservationOrderId, reservationId, parameters, options)
                .then(function (lroPoller) { return lroPoller.pollUntilFinished(); });
        };
        Reservation.prototype.listRevisions = function (reservationId, reservationOrderId, options, callback) {
            return this.client.sendOperationRequest({
                reservationId: reservationId,
                reservationOrderId: reservationOrderId,
                options: options
            }, listRevisionsOperationSpec, callback);
        };
        /**
         * Get Available Scopes for `Reservation`.
         * @summary Get Available Scopes for `Reservation`.
         * @param reservationOrderId Order Id of the reservation
         * @param reservationId Id of the Reservation Item
         * @param body
         * @param [options] The optional parameters
         * @returns Promise<msRestAzure.LROPoller>
         */
        Reservation.prototype.beginAvailableScopes = function (reservationOrderId, reservationId, body, options) {
            return this.client.sendLRORequest({
                reservationOrderId: reservationOrderId,
                reservationId: reservationId,
                body: body,
                options: options
            }, beginAvailableScopesOperationSpec, options);
        };
        /**
         * Split a `Reservation` into two `Reservation`s with specified quantity distribution.
         * @summary Split the `Reservation`.
         * @param reservationOrderId Order Id of the reservation
         * @param body Information needed to Split a reservation item
         * @param [options] The optional parameters
         * @returns Promise<msRestAzure.LROPoller>
         */
        Reservation.prototype.beginSplit = function (reservationOrderId, body, options) {
            return this.client.sendLRORequest({
                reservationOrderId: reservationOrderId,
                body: body,
                options: options
            }, beginSplitOperationSpec, options);
        };
        /**
         * Merge the specified `Reservation`s into a new `Reservation`. The two `Reservation`s being merged
         * must have same properties.
         * @summary Merges two `Reservation`s.
         * @param reservationOrderId Order Id of the reservation
         * @param body Information needed for commercial request for a reservation
         * @param [options] The optional parameters
         * @returns Promise<msRestAzure.LROPoller>
         */
        Reservation.prototype.beginMerge = function (reservationOrderId, body, options) {
            return this.client.sendLRORequest({
                reservationOrderId: reservationOrderId,
                body: body,
                options: options
            }, beginMergeOperationSpec, options);
        };
        /**
         * Updates the applied scopes of the `Reservation`.
         * @summary Updates a `Reservation`.
         * @param reservationOrderId Order Id of the reservation
         * @param reservationId Id of the Reservation Item
         * @param parameters Information needed to patch a reservation item
         * @param [options] The optional parameters
         * @returns Promise<msRestAzure.LROPoller>
         */
        Reservation.prototype.beginUpdate = function (reservationOrderId, reservationId, parameters, options) {
            return this.client.sendLRORequest({
                reservationOrderId: reservationOrderId,
                reservationId: reservationId,
                parameters: parameters,
                options: options
            }, beginUpdateOperationSpec$1, options);
        };
        Reservation.prototype.listNext = function (nextPageLink, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink,
                options: options
            }, listNextOperationSpec$2, callback);
        };
        Reservation.prototype.listRevisionsNext = function (nextPageLink, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink,
                options: options
            }, listRevisionsNextOperationSpec, callback);
        };
        return Reservation;
    }());
    // Operation Specifications
    var serializer$3 = new msRest.Serializer(Mappers$4);
    var listOperationSpec$2 = {
        httpMethod: "GET",
        path: "providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/reservations",
        urlParameters: [
            reservationOrderId
        ],
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ReservationList
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$3
    };
    var getOperationSpec$2 = {
        httpMethod: "GET",
        path: "providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/reservations/{reservationId}",
        urlParameters: [
            reservationId,
            reservationOrderId
        ],
        queryParameters: [
            apiVersion1,
            expand0
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ReservationResponse
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$3
    };
    var listRevisionsOperationSpec = {
        httpMethod: "GET",
        path: "providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/reservations/{reservationId}/revisions",
        urlParameters: [
            reservationId,
            reservationOrderId
        ],
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ReservationList
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$3
    };
    var beginAvailableScopesOperationSpec = {
        httpMethod: "POST",
        path: "providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/reservations/{reservationId}/availableScopes",
        urlParameters: [
            reservationOrderId,
            reservationId
        ],
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "body",
            mapper: {
                required: true,
                serializedName: "body",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "String"
                        }
                    }
                }
            }
        },
        responses: {
            200: {
                bodyMapper: Properties
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$3
    };
    var beginSplitOperationSpec = {
        httpMethod: "POST",
        path: "providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/split",
        urlParameters: [
            reservationOrderId
        ],
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "body",
            mapper: __assign(__assign({}, SplitRequest), { required: true })
        },
        responses: {
            200: {
                bodyMapper: {
                    serializedName: "parsedResponse",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "ReservationResponse"
                            }
                        }
                    }
                }
            },
            202: {},
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$3
    };
    var beginMergeOperationSpec = {
        httpMethod: "POST",
        path: "providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/merge",
        urlParameters: [
            reservationOrderId
        ],
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "body",
            mapper: __assign(__assign({}, MergeRequest), { required: true })
        },
        responses: {
            200: {
                bodyMapper: {
                    serializedName: "parsedResponse",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "ReservationResponse"
                            }
                        }
                    }
                }
            },
            202: {},
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$3
    };
    var beginUpdateOperationSpec$1 = {
        httpMethod: "PATCH",
        path: "providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}/reservations/{reservationId}",
        urlParameters: [
            reservationOrderId,
            reservationId
        ],
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "parameters",
            mapper: __assign(__assign({}, Patch), { required: true })
        },
        responses: {
            200: {
                bodyMapper: ReservationResponse
            },
            202: {},
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$3
    };
    var listNextOperationSpec$2 = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ReservationList
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$3
    };
    var listRevisionsNextOperationSpec = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ReservationList
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$3
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var Mappers$5 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        Actions: Actions,
        AqiSettings: AqiSettings,
        AutoQuotaIncreaseDetail: AutoQuotaIncreaseDetail,
        BaseResource: BaseResource,
        CalculatePriceResponse: CalculatePriceResponse,
        CalculatePriceResponseProperties: CalculatePriceResponseProperties,
        CalculatePriceResponsePropertiesBillingCurrencyTotal: CalculatePriceResponsePropertiesBillingCurrencyTotal,
        CalculatePriceResponsePropertiesPricingCurrencyTotal: CalculatePriceResponsePropertiesPricingCurrencyTotal,
        CurrentQuotaLimit: CurrentQuotaLimit,
        CurrentQuotaLimitBase: CurrentQuotaLimitBase,
        EmailAction: EmailAction,
        EmailActions: EmailActions,
        ErrorModel: ErrorModel,
        ExtendedErrorInfo: ExtendedErrorInfo,
        ExtendedStatusInfo: ExtendedStatusInfo,
        PaymentDetail: PaymentDetail,
        Price: Price,
        PurchaseRequest: PurchaseRequest,
        PurchaseRequestPropertiesReservedResourceProperties: PurchaseRequestPropertiesReservedResourceProperties,
        QuotaProperties: QuotaProperties,
        QuotaRequestDetails: QuotaRequestDetails,
        QuotaRequestOneResourceSubmitResponse: QuotaRequestOneResourceSubmitResponse,
        QuotaRequestProperties: QuotaRequestProperties,
        QuotaRequestSubmitResponse: QuotaRequestSubmitResponse,
        RenewPropertiesResponse: RenewPropertiesResponse,
        RenewPropertiesResponseBillingCurrencyTotal: RenewPropertiesResponseBillingCurrencyTotal,
        RenewPropertiesResponsePricingCurrencyTotal: RenewPropertiesResponsePricingCurrencyTotal,
        ReservationMergeProperties: ReservationMergeProperties,
        ReservationOrderBillingPlanInformation: ReservationOrderBillingPlanInformation,
        ReservationOrderList: ReservationOrderList,
        ReservationOrderResponse: ReservationOrderResponse,
        ReservationProperties: ReservationProperties,
        ReservationResponse: ReservationResponse,
        ReservationSplitProperties: ReservationSplitProperties,
        ResourceName: ResourceName,
        SkuName: SkuName,
        SubRequest: SubRequest,
        SupportRequestAction: SupportRequestAction
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    /** Class representing a ReservationOrder. */
    var ReservationOrder = /** @class */ (function () {
        /**
         * Create a ReservationOrder.
         * @param {AzureReservationAPIContext} client Reference to the service client.
         */
        function ReservationOrder(client) {
            this.client = client;
        }
        ReservationOrder.prototype.calculate = function (body, options, callback) {
            return this.client.sendOperationRequest({
                body: body,
                options: options
            }, calculateOperationSpec, callback);
        };
        ReservationOrder.prototype.list = function (options, callback) {
            return this.client.sendOperationRequest({
                options: options
            }, listOperationSpec$3, callback);
        };
        /**
         * Purchase `ReservationOrder` and create resource under the specified URI.
         * @summary Purchase `ReservationOrder`
         * @param reservationOrderId Order Id of the reservation
         * @param body Information needed for calculate or purchase reservation
         * @param [options] The optional parameters
         * @returns Promise<Models.ReservationOrderPurchaseResponse>
         */
        ReservationOrder.prototype.purchase = function (reservationOrderId, body, options) {
            return this.beginPurchase(reservationOrderId, body, options)
                .then(function (lroPoller) { return lroPoller.pollUntilFinished(); });
        };
        ReservationOrder.prototype.get = function (reservationOrderId, options, callback) {
            return this.client.sendOperationRequest({
                reservationOrderId: reservationOrderId,
                options: options
            }, getOperationSpec$3, callback);
        };
        /**
         * Purchase `ReservationOrder` and create resource under the specified URI.
         * @summary Purchase `ReservationOrder`
         * @param reservationOrderId Order Id of the reservation
         * @param body Information needed for calculate or purchase reservation
         * @param [options] The optional parameters
         * @returns Promise<msRestAzure.LROPoller>
         */
        ReservationOrder.prototype.beginPurchase = function (reservationOrderId, body, options) {
            return this.client.sendLRORequest({
                reservationOrderId: reservationOrderId,
                body: body,
                options: options
            }, beginPurchaseOperationSpec, options);
        };
        ReservationOrder.prototype.listNext = function (nextPageLink, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink,
                options: options
            }, listNextOperationSpec$3, callback);
        };
        return ReservationOrder;
    }());
    // Operation Specifications
    var serializer$4 = new msRest.Serializer(Mappers$5);
    var calculateOperationSpec = {
        httpMethod: "POST",
        path: "providers/Microsoft.Capacity/calculatePrice",
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "body",
            mapper: __assign(__assign({}, PurchaseRequest), { required: true })
        },
        responses: {
            200: {
                bodyMapper: CalculatePriceResponse
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$4
    };
    var listOperationSpec$3 = {
        httpMethod: "GET",
        path: "providers/Microsoft.Capacity/reservationOrders",
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ReservationOrderList
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$4
    };
    var getOperationSpec$3 = {
        httpMethod: "GET",
        path: "providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}",
        urlParameters: [
            reservationOrderId
        ],
        queryParameters: [
            apiVersion1,
            expand1
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ReservationOrderResponse
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$4
    };
    var beginPurchaseOperationSpec = {
        httpMethod: "PUT",
        path: "providers/Microsoft.Capacity/reservationOrders/{reservationOrderId}",
        urlParameters: [
            reservationOrderId
        ],
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        requestBody: {
            parameterPath: "body",
            mapper: __assign(__assign({}, PurchaseRequest), { required: true })
        },
        responses: {
            200: {
                bodyMapper: ReservationOrderResponse
            },
            202: {
                bodyMapper: ReservationOrderResponse
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$4
    };
    var listNextOperationSpec$3 = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: ReservationOrderList
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$4
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is regenerated.
     */

    var Mappers$6 = /*#__PURE__*/Object.freeze({
        __proto__: null,
        ErrorModel: ErrorModel,
        ExtendedErrorInfo: ExtendedErrorInfo,
        OperationDisplay: OperationDisplay,
        OperationList: OperationList,
        OperationResponse: OperationResponse
    });

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    /** Class representing a Operation. */
    var Operation = /** @class */ (function () {
        /**
         * Create a Operation.
         * @param {AzureReservationAPIContext} client Reference to the service client.
         */
        function Operation(client) {
            this.client = client;
        }
        Operation.prototype.list = function (options, callback) {
            return this.client.sendOperationRequest({
                options: options
            }, listOperationSpec$4, callback);
        };
        Operation.prototype.listNext = function (nextPageLink, options, callback) {
            return this.client.sendOperationRequest({
                nextPageLink: nextPageLink,
                options: options
            }, listNextOperationSpec$4, callback);
        };
        return Operation;
    }());
    // Operation Specifications
    var serializer$5 = new msRest.Serializer(Mappers$6);
    var listOperationSpec$4 = {
        httpMethod: "GET",
        path: "providers/Microsoft.Capacity/operations",
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: OperationList
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$5
    };
    var listNextOperationSpec$4 = {
        httpMethod: "GET",
        baseUrl: "https://management.azure.com",
        path: "{nextLink}",
        urlParameters: [
            nextPageLink
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: OperationList
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$5
    };

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    var packageName = "@azure/arm-reservations";
    var packageVersion = "5.0.0";
    var AzureReservationAPIContext = /** @class */ (function (_super) {
        __extends(AzureReservationAPIContext, _super);
        /**
         * Initializes a new instance of the AzureReservationAPI class.
         * @param credentials Credentials needed for the client to connect to Azure.
         * @param [options] The parameter options
         */
        function AzureReservationAPIContext(credentials, options) {
            var _this = this;
            if (credentials == undefined) {
                throw new Error('\'credentials\' cannot be null.');
            }
            if (!options) {
                options = {};
            }
            if (!options.userAgent) {
                var defaultUserAgent = msRestAzure.getDefaultUserAgentValue();
                options.userAgent = packageName + "/" + packageVersion + " " + defaultUserAgent;
            }
            _this = _super.call(this, credentials, options) || this;
            _this.acceptLanguage = 'en-US';
            _this.longRunningOperationRetryTimeout = 30;
            _this.baseUri = options.baseUri || _this.baseUri || "https://management.azure.com";
            _this.requestContentType = "application/json; charset=utf-8";
            _this.credentials = credentials;
            if (options.acceptLanguage !== null && options.acceptLanguage !== undefined) {
                _this.acceptLanguage = options.acceptLanguage;
            }
            if (options.longRunningOperationRetryTimeout !== null && options.longRunningOperationRetryTimeout !== undefined) {
                _this.longRunningOperationRetryTimeout = options.longRunningOperationRetryTimeout;
            }
            return _this;
        }
        return AzureReservationAPIContext;
    }(msRestAzure.AzureServiceClient));

    /*
     * Copyright (c) Microsoft Corporation. All rights reserved.
     * Licensed under the MIT License. See License.txt in the project root for
     * license information.
     *
     * Code generated by Microsoft (R) AutoRest Code Generator.
     * Changes may cause incorrect behavior and will be lost if the code is
     * regenerated.
     */
    var AzureReservationAPI = /** @class */ (function (_super) {
        __extends(AzureReservationAPI, _super);
        /**
         * Initializes a new instance of the AzureReservationAPI class.
         * @param credentials Credentials needed for the client to connect to Azure.
         * @param [options] The parameter options
         */
        function AzureReservationAPI(credentials, options) {
            var _this = _super.call(this, credentials, options) || this;
            _this.quota = new Quota(_this);
            _this.quotaRequestStatus = new QuotaRequestStatus(_this);
            _this.autoQuotaIncrease = new AutoQuotaIncrease(_this);
            _this.reservation = new Reservation(_this);
            _this.reservationOrder = new ReservationOrder(_this);
            _this.operation = new Operation(_this);
            return _this;
        }
        AzureReservationAPI.prototype.getCatalog = function (subscriptionId, reservedResourceType, options, callback) {
            return this.sendOperationRequest({
                subscriptionId: subscriptionId,
                reservedResourceType: reservedResourceType,
                options: options
            }, getCatalogOperationSpec, callback);
        };
        AzureReservationAPI.prototype.getAppliedReservationList = function (subscriptionId, options, callback) {
            return this.sendOperationRequest({
                subscriptionId: subscriptionId,
                options: options
            }, getAppliedReservationListOperationSpec, callback);
        };
        return AzureReservationAPI;
    }(AzureReservationAPIContext));
    // Operation Specifications
    var serializer$6 = new msRest.Serializer(Mappers);
    var getCatalogOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/catalogs",
        urlParameters: [
            subscriptionId
        ],
        queryParameters: [
            apiVersion1,
            reservedResourceType,
            location1
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: {
                    serializedName: "parsedResponse",
                    type: {
                        name: "Sequence",
                        element: {
                            type: {
                                name: "Composite",
                                className: "Catalog"
                            }
                        }
                    }
                }
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$6
    };
    var getAppliedReservationListOperationSpec = {
        httpMethod: "GET",
        path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/appliedReservations",
        urlParameters: [
            subscriptionId
        ],
        queryParameters: [
            apiVersion1
        ],
        headerParameters: [
            acceptLanguage
        ],
        responses: {
            200: {
                bodyMapper: AppliedReservations
            },
            default: {
                bodyMapper: ErrorModel
            }
        },
        serializer: serializer$6
    };

    exports.AutoQuotaIncrease = AutoQuotaIncrease;
    exports.AzureReservationAPI = AzureReservationAPI;
    exports.AzureReservationAPIContext = AzureReservationAPIContext;
    exports.AzureReservationAPIMappers = Mappers;
    exports.AzureReservationAPIModels = index;
    exports.Operation = Operation;
    exports.Quota = Quota;
    exports.QuotaRequestStatus = QuotaRequestStatus;
    exports.Reservation = Reservation;
    exports.ReservationOrder = ReservationOrder;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=arm-reservations.js.map
