/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import { __extends } from "tslib";
import * as msRest from "@azure/ms-rest-js";
import * as Models from "./models";
import * as Mappers from "./models/mappers";
import * as Parameters from "./models/parameters";
import * as operations from "./operations";
import { AzureReservationAPIContext } from "./azureReservationAPIContext";
var AzureReservationAPI = /** @class */ (function (_super) {
    __extends(AzureReservationAPI, _super);
    /**
     * Initializes a new instance of the AzureReservationAPI class.
     * @param credentials Credentials needed for the client to connect to Azure.
     * @param [options] The parameter options
     */
    function AzureReservationAPI(credentials, options) {
        var _this = _super.call(this, credentials, options) || this;
        _this.quota = new operations.Quota(_this);
        _this.quotaRequestStatus = new operations.QuotaRequestStatus(_this);
        _this.autoQuotaIncrease = new operations.AutoQuotaIncrease(_this);
        _this.reservation = new operations.Reservation(_this);
        _this.reservationOrder = new operations.ReservationOrder(_this);
        _this.operation = new operations.Operation(_this);
        return _this;
    }
    AzureReservationAPI.prototype.getCatalog = function (subscriptionId, reservedResourceType, options, callback) {
        return this.sendOperationRequest({
            subscriptionId: subscriptionId,
            reservedResourceType: reservedResourceType,
            options: options
        }, getCatalogOperationSpec, callback);
    };
    AzureReservationAPI.prototype.getAppliedReservationList = function (subscriptionId, options, callback) {
        return this.sendOperationRequest({
            subscriptionId: subscriptionId,
            options: options
        }, getAppliedReservationListOperationSpec, callback);
    };
    return AzureReservationAPI;
}(AzureReservationAPIContext));
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var getCatalogOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/catalogs",
    urlParameters: [
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion1,
        Parameters.reservedResourceType,
        Parameters.location1
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: {
                serializedName: "parsedResponse",
                type: {
                    name: "Sequence",
                    element: {
                        type: {
                            name: "Composite",
                            className: "Catalog"
                        }
                    }
                }
            }
        },
        default: {
            bodyMapper: Mappers.ErrorModel
        }
    },
    serializer: serializer
};
var getAppliedReservationListOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/appliedReservations",
    urlParameters: [
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion1
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.AppliedReservations
        },
        default: {
            bodyMapper: Mappers.ErrorModel
        }
    },
    serializer: serializer
};
export { AzureReservationAPI, AzureReservationAPIContext, Models as AzureReservationAPIModels, Mappers as AzureReservationAPIMappers };
export * from "./operations";
//# sourceMappingURL=azureReservationAPI.js.map