/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
export var acceptLanguage = {
    parameterPath: "acceptLanguage",
    mapper: {
        serializedName: "accept-language",
        defaultValue: 'en-US',
        type: {
            name: "String"
        }
    }
};
export var apiVersion0 = {
    parameterPath: "apiVersion",
    mapper: {
        required: true,
        isConstant: true,
        serializedName: "api-version",
        defaultValue: '2019-07-19-preview',
        type: {
            name: "String"
        }
    }
};
export var apiVersion1 = {
    parameterPath: "apiVersion",
    mapper: {
        required: true,
        isConstant: true,
        serializedName: "api-version",
        defaultValue: '2019-04-01',
        type: {
            name: "String"
        }
    }
};
export var expand0 = {
    parameterPath: [
        "options",
        "expand"
    ],
    mapper: {
        serializedName: "expand",
        type: {
            name: "String"
        }
    }
};
export var expand1 = {
    parameterPath: [
        "options",
        "expand"
    ],
    mapper: {
        serializedName: "$expand",
        type: {
            name: "String"
        }
    }
};
export var filter = {
    parameterPath: [
        "options",
        "filter"
    ],
    mapper: {
        serializedName: "$filter",
        type: {
            name: "String"
        }
    }
};
export var id = {
    parameterPath: "id",
    mapper: {
        required: true,
        serializedName: "id",
        type: {
            name: "String"
        }
    }
};
export var location0 = {
    parameterPath: "location",
    mapper: {
        required: true,
        serializedName: "location",
        type: {
            name: "String"
        }
    }
};
export var location1 = {
    parameterPath: [
        "options",
        "location"
    ],
    mapper: {
        serializedName: "location",
        type: {
            name: "String"
        }
    }
};
export var nextPageLink = {
    parameterPath: "nextPageLink",
    mapper: {
        required: true,
        serializedName: "nextLink",
        type: {
            name: "String"
        }
    },
    skipEncoding: true
};
export var providerId = {
    parameterPath: "providerId",
    mapper: {
        required: true,
        serializedName: "providerId",
        type: {
            name: "String"
        }
    }
};
export var reservationId = {
    parameterPath: "reservationId",
    mapper: {
        required: true,
        serializedName: "reservationId",
        type: {
            name: "String"
        }
    }
};
export var reservationOrderId = {
    parameterPath: "reservationOrderId",
    mapper: {
        required: true,
        serializedName: "reservationOrderId",
        type: {
            name: "String"
        }
    }
};
export var reservedResourceType = {
    parameterPath: "reservedResourceType",
    mapper: {
        required: true,
        serializedName: "reservedResourceType",
        type: {
            name: "String"
        }
    }
};
export var resourceName = {
    parameterPath: "resourceName",
    mapper: {
        required: true,
        serializedName: "resourceName",
        type: {
            name: "String"
        }
    }
};
export var skiptoken = {
    parameterPath: [
        "options",
        "skiptoken"
    ],
    mapper: {
        serializedName: "$skiptoken",
        type: {
            name: "String"
        }
    }
};
export var subscriptionId = {
    parameterPath: "subscriptionId",
    mapper: {
        required: true,
        serializedName: "subscriptionId",
        type: {
            name: "String"
        }
    }
};
export var top = {
    parameterPath: [
        "options",
        "top"
    ],
    mapper: {
        serializedName: "$top",
        constraints: {
            InclusiveMinimum: 1
        },
        type: {
            name: "Number"
        }
    }
};
//# sourceMappingURL=parameters.js.map