import * as msRest from "@azure/ms-rest-js";
import * as Models from "../models";
import { AzureReservationAPIContext } from "../azureReservationAPIContext";
/** Class representing a AutoQuotaIncrease. */
export declare class AutoQuotaIncrease {
    private readonly client;
    /**
     * Create a AutoQuotaIncrease.
     * @param {AzureReservationAPIContext} client Reference to the service client.
     */
    constructor(client: AzureReservationAPIContext);
    /**
     * Gets the Auto Quota Increase enrollment details for the specified subscription.
     * @param subscriptionId Azure subscription id.
     * @param [options] The optional parameters
     * @returns Promise<Models.AutoQuotaIncreaseGetPropertiesResponse>
     */
    getProperties(subscriptionId: string, options?: msRest.RequestOptionsBase): Promise<Models.AutoQuotaIncreaseGetPropertiesResponse>;
    /**
     * @param subscriptionId Azure subscription id.
     * @param callback The callback
     */
    getProperties(subscriptionId: string, callback: msRest.ServiceCallback<Models.AutoQuotaIncreaseDetail>): void;
    /**
     * @param subscriptionId Azure subscription id.
     * @param options The optional parameters
     * @param callback The callback
     */
    getProperties(subscriptionId: string, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AutoQuotaIncreaseDetail>): void;
    /**
     * Sets the Auto Quota Increase enrollment properties for the specified subscription.
     * @param subscriptionId Azure subscription id.
     * @param autoQuotaIncreaseRequest Auto Quota increase request payload.
     * @param [options] The optional parameters
     * @returns Promise<Models.AutoQuotaIncreaseCreateResponse>
     */
    create(subscriptionId: string, autoQuotaIncreaseRequest: Models.AutoQuotaIncreaseDetail, options?: msRest.RequestOptionsBase): Promise<Models.AutoQuotaIncreaseCreateResponse>;
    /**
     * @param subscriptionId Azure subscription id.
     * @param autoQuotaIncreaseRequest Auto Quota increase request payload.
     * @param callback The callback
     */
    create(subscriptionId: string, autoQuotaIncreaseRequest: Models.AutoQuotaIncreaseDetail, callback: msRest.ServiceCallback<Models.AutoQuotaIncreaseDetail>): void;
    /**
     * @param subscriptionId Azure subscription id.
     * @param autoQuotaIncreaseRequest Auto Quota increase request payload.
     * @param options The optional parameters
     * @param callback The callback
     */
    create(subscriptionId: string, autoQuotaIncreaseRequest: Models.AutoQuotaIncreaseDetail, options: msRest.RequestOptionsBase, callback: msRest.ServiceCallback<Models.AutoQuotaIncreaseDetail>): void;
}
//# sourceMappingURL=autoQuotaIncrease.d.ts.map