/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import { __assign } from "tslib";
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/autoQuotaIncreaseMappers";
import * as Parameters from "../models/parameters";
/** Class representing a AutoQuotaIncrease. */
var AutoQuotaIncrease = /** @class */ (function () {
    /**
     * Create a AutoQuotaIncrease.
     * @param {AzureReservationAPIContext} client Reference to the service client.
     */
    function AutoQuotaIncrease(client) {
        this.client = client;
    }
    AutoQuotaIncrease.prototype.getProperties = function (subscriptionId, options, callback) {
        return this.client.sendOperationRequest({
            subscriptionId: subscriptionId,
            options: options
        }, getPropertiesOperationSpec, callback);
    };
    AutoQuotaIncrease.prototype.create = function (subscriptionId, autoQuotaIncreaseRequest, options, callback) {
        return this.client.sendOperationRequest({
            subscriptionId: subscriptionId,
            autoQuotaIncreaseRequest: autoQuotaIncreaseRequest,
            options: options
        }, createOperationSpec, callback);
    };
    return AutoQuotaIncrease;
}());
export { AutoQuotaIncrease };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var getPropertiesOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/autoQuotaIncrease",
    urlParameters: [
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.AutoQuotaIncreaseDetail
        },
        default: {
            bodyMapper: Mappers.ExceptionResponse
        }
    },
    serializer: serializer
};
var createOperationSpec = {
    httpMethod: "PUT",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/autoQuotaIncrease",
    urlParameters: [
        Parameters.subscriptionId
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    requestBody: {
        parameterPath: "autoQuotaIncreaseRequest",
        mapper: __assign(__assign({}, Mappers.AutoQuotaIncreaseDetail), { required: true })
    },
    responses: {
        200: {
            bodyMapper: Mappers.AutoQuotaIncreaseDetail
        },
        default: {
            bodyMapper: Mappers.ExceptionResponse
        }
    },
    serializer: serializer
};
//# sourceMappingURL=autoQuotaIncrease.js.map