/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */
import * as msRest from "@azure/ms-rest-js";
import * as Mappers from "../models/quotaRequestStatusMappers";
import * as Parameters from "../models/parameters";
/** Class representing a QuotaRequestStatus. */
var QuotaRequestStatus = /** @class */ (function () {
    /**
     * Create a QuotaRequestStatus.
     * @param {AzureReservationAPIContext} client Reference to the service client.
     */
    function QuotaRequestStatus(client) {
        this.client = client;
    }
    QuotaRequestStatus.prototype.get = function (subscriptionId, providerId, location, id, options, callback) {
        return this.client.sendOperationRequest({
            subscriptionId: subscriptionId,
            providerId: providerId,
            location: location,
            id: id,
            options: options
        }, getOperationSpec, callback);
    };
    QuotaRequestStatus.prototype.list = function (subscriptionId, providerId, location, options, callback) {
        return this.client.sendOperationRequest({
            subscriptionId: subscriptionId,
            providerId: providerId,
            location: location,
            options: options
        }, listOperationSpec, callback);
    };
    QuotaRequestStatus.prototype.listNext = function (nextPageLink, options, callback) {
        return this.client.sendOperationRequest({
            nextPageLink: nextPageLink,
            options: options
        }, listNextOperationSpec, callback);
    };
    return QuotaRequestStatus;
}());
export { QuotaRequestStatus };
// Operation Specifications
var serializer = new msRest.Serializer(Mappers);
var getOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/resourceProviders/{providerId}/locations/{location}/serviceLimitsRequests/{id}",
    urlParameters: [
        Parameters.subscriptionId,
        Parameters.providerId,
        Parameters.location0,
        Parameters.id
    ],
    queryParameters: [
        Parameters.apiVersion0
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.QuotaRequestDetails
        },
        default: {
            bodyMapper: Mappers.ExceptionResponse
        }
    },
    serializer: serializer
};
var listOperationSpec = {
    httpMethod: "GET",
    path: "subscriptions/{subscriptionId}/providers/Microsoft.Capacity/resourceProviders/{providerId}/locations/{location}/serviceLimitsRequests",
    urlParameters: [
        Parameters.subscriptionId,
        Parameters.providerId,
        Parameters.location0
    ],
    queryParameters: [
        Parameters.apiVersion0,
        Parameters.filter,
        Parameters.top,
        Parameters.skiptoken
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.QuotaRequestDetailsList
        },
        default: {
            bodyMapper: Mappers.ExceptionResponse
        }
    },
    serializer: serializer
};
var listNextOperationSpec = {
    httpMethod: "GET",
    baseUrl: "https://management.azure.com",
    path: "{nextLink}",
    urlParameters: [
        Parameters.nextPageLink
    ],
    headerParameters: [
        Parameters.acceptLanguage
    ],
    responses: {
        200: {
            bodyMapper: Mappers.QuotaRequestDetailsList
        },
        default: {
            bodyMapper: Mappers.ExceptionResponse
        }
    },
    serializer: serializer
};
//# sourceMappingURL=quotaRequestStatus.js.map